program Project2;

uses
  windows,
  madres,
  sysutils;

{$R *.res}

function MAKELANGID(sPrimaryLanguage : Word;
                    sSubLanguage : Word) : Word; 
begin 
  result := (sSubLanguage shl 10) or 
             sPrimaryLanguage; 
end;

function ExtractExeIcon(exeFile, iconGroup: string; language: word; target:string) : boolean;
var resUpdateHandle : dword;
    c:TPIconGroup;
begin
  resUpdateHandle := BeginUpdateResourceW(PWideChar(wideString(exeFile)), false);
  if resUpdateHandle <> 0 then
  begin
    if (icongroup='MAINICON') or GetIconGroupResourceW(resUpdateHandle, PWideChar(wideString(iconGroup)), language, c) then
      result := SaveIconGroupResourceW(resUpdateHandle, PWideChar(wideString(iconGroup)), language, PWideChar(WideString(target)))
                                                                                             else
    if StrToIntDef(iconGroup, -1)>-1 then
      result := SaveIconGroupResourceW(resUpdateHandle, PWideChar(pointer(strtoint(iconGroup))), language, PWideChar(WideString(target)))
    else
      result := false;
    result := EndUpdateResourceW(resUpdateHandle, false) and result;
  end else
    result := false;
end;

begin
  ExtractExeIcon('test.exe', 'MAINICON', makelangid(LANG_ROMANIAN,SUBLANG_DEFAULT), 'saved_main.ico');
  ExtractExeIcon('test.exe', '128', makelangid(LANG_ENGLISH,SUBLANG_DEFAULT), 'saved_128.ico');
  ExtractExeIcon('test.exe', 'TEST', makelangid(LANG_ENGLISH,SUBLANG_DEFAULT), 'saved_test.ico');
end.

